from barcode import EAN13, Code128, Code39

BARCODE_MAP = {
  'EAN_13': EAN13,
  'CODE_128': Code128,
  'CODE_39': Code39,
}

def get_bar_code(meta):
    f = BARCODE_MAP.get(meta['format'], None)
    if f is not None:
        return f(meta['content']).render()

    return None