SET ":tool" = 'upload';
SET ":hash" = COALESCE($hash, '');
SET ":hash" = sqlpage.url_encode(:hash);
SET ":title" = 'Upload';
SET ":color" = '#f59f00';
SET ":tabler_color" = 'yellow';
SET ":image" = '/static/upload/upload-favicon_square.svg';
SET ":favicon" = :image;
SET ":manifest" = '/static/upload/manifest.json';
SET ":action" = COALESCE($action, :action, '');
SET ":inner" = (CASE :action
  WHEN 'open' THEN 'sqlpage/Open.sql'
  ELSE 'upload/Index.sql'
END);
SET ":file_name" = sqlpage.uploaded_file_name('content');
SET ":mime_type" = sqlpage.uploaded_file_mime_type('content');
-- although using a variable works, docs say to pass the function as first argument
-- https://sql.ophir.dev/functions.sql?function=read_file_as_data_url#function
SET ":content" = sqlpage.read_file_as_data_url(sqlpage.uploaded_file_path('content'));

SELECT 'dynamic' AS component, sqlpage.run_sql('upload/temp.sql') AS properties
WHERE :content IS NOT NULL AND $rowid IS NULL;

SET ":file_name" = (SELECT name FROM upload_temp WHERE rowid = $rowid);
SET ":mime_type" = (SELECT mime FROM upload_temp WHERE rowid = $rowid);
SET ":content" = CAST($rowid AS INTEGER);

SELECT 'dynamic' AS component, sqlpage.run_sql('sqlpage/theme.sql') AS properties
--WHERE $rowid IS NULL
;
SELECT 'dynamic' AS component, sqlpage.run_sql('sqlpage/Style.sql') AS properties
--WHERE $rowid IS NULL
;
SET ":spinner" = :content IS NOT NULL OR $rowid IS NOT NULL; --COALESCE($rowid, '') <> '';
SELECT 'loader-start' AS component
, 'lg' AS size
, :tabler_color AS color
, '' AS spinner
WHERE :spinner
;
SELECT 'progress' AS component
, 'lg' AS size
, :tabler_color AS color
WHERE :spinner
;
SELECT 'dynamic' AS component, sqlpage.run_sql(:inner) AS properties;
